"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentCompareVersionPicker = void 0;
const react_1 = __importDefault(require("react"));
const component_ui_version_dropdown_1 = require("@teambit/component.ui.version-dropdown");
const component_ui_component_compare_hooks_use_component_compare_url_1 = require("@teambit/component.ui.component-compare.hooks.use-component-compare-url");
const component_ui_component_compare_context_1 = require("@teambit/component.ui.component-compare.context");
const component_1 = require("@teambit/component");
const classnames_1 = __importDefault(require("classnames"));
const semver = __importStar(require("semver"));
const component_compare_version_picker_module_scss_1 = __importDefault(require("./component-compare-version-picker.module.scss"));
function ComponentCompareVersionPicker({ className, host, customUseComponent, }) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    const componentCompare = (0, component_ui_component_compare_context_1.useComponentCompare)();
    const compare = (_a = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _a === void 0 ? void 0 : _a.model;
    const componentId = compare === null || compare === void 0 ? void 0 : compare.id.toString();
    const componentWithLogsOptions = {
        customUseComponent,
    };
    const useVersions = (props) => {
        const { skip } = props || {};
        const { componentLogs = {}, loading: loadingLogs } = (0, component_1.useComponent)(host, componentId, Object.assign(Object.assign({}, componentWithLogsOptions), { skip }));
        return Object.assign(Object.assign({ loading: loadingLogs }, componentLogs), { snaps: (componentLogs.logs || [])
                .map((snap) => (Object.assign(Object.assign({}, snap), { version: snap.hash })))
                .filter((log) => {
                var _a;
                if (log.tag)
                    return false;
                const version = log.hash;
                return ((_a = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _a === void 0 ? void 0 : _a.hasLocalChanges) || version !== (compare === null || compare === void 0 ? void 0 : compare.id.version);
            }), tags: (componentLogs.logs || [])
                .map((tag) => (Object.assign(Object.assign({}, tag), { version: tag.tag })))
                .filter((log) => {
                var _a;
                if (!log.tag)
                    return false;
                const version = log.tag;
                return ((_a = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _a === void 0 ? void 0 : _a.hasLocalChanges) || version !== (compare === null || compare === void 0 ? void 0 : compare.id.version);
            }) });
    };
    const useVersion = (props) => {
        const { version, skip } = props || {};
        const { tags, snaps, loading } = useVersions({ skip });
        const isTag = react_1.default.useMemo(() => semver.valid(version), [loading, version]);
        if (isTag) {
            return react_1.default.useMemo(() => tags === null || tags === void 0 ? void 0 : tags.find((tag) => tag.tag === version), [loading, tags === null || tags === void 0 ? void 0 : tags.length, version]);
        }
        return react_1.default.useMemo(() => snaps === null || snaps === void 0 ? void 0 : snaps.find((snap) => snap.version === version), [loading, snaps === null || snaps === void 0 ? void 0 : snaps.length, version]);
    };
    const compareVersion = ((_b = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _b === void 0 ? void 0 : _b.hasLocalChanges) ? 'workspace' : compare === null || compare === void 0 ? void 0 : compare.version;
    const baseVersion = (_c = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.base) === null || _c === void 0 ? void 0 : _c.model.version;
    const key = `base-compare-version-dropdown-${(_d = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _d === void 0 ? void 0 : _d.model.id.toString()}`;
    return (react_1.default.createElement("div", { className: component_compare_version_picker_module_scss_1.default.componentCompareVersionPicker },
        react_1.default.createElement("div", { className: (0, classnames_1.default)(component_compare_version_picker_module_scss_1.default.dropdownContainer) },
            react_1.default.createElement("span", { className: (0, classnames_1.default)(component_compare_version_picker_module_scss_1.default.rightPad, component_compare_version_picker_module_scss_1.default.titleText) }, "Comparing"),
            react_1.default.createElement(component_ui_version_dropdown_1.VersionDropdown, { key: key, className: (0, classnames_1.default)(component_compare_version_picker_module_scss_1.default.componentCompareVersionContainer, component_compare_version_picker_module_scss_1.default.left, className), dropdownClassName: component_compare_version_picker_module_scss_1.default.componentCompareDropdown, placeholderClassName: component_compare_version_picker_module_scss_1.default.componentCompareVersionPlaceholder, menuClassName: (0, classnames_1.default)(component_compare_version_picker_module_scss_1.default.componentCompareVersionMenu, component_compare_version_picker_module_scss_1.default.showMenuOverNav), currentVersion: baseVersion, loading: componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.loading, overrideVersionHref: (_baseVersion) => {
                    return (0, component_ui_component_compare_hooks_use_component_compare_url_1.useUpdatedUrlFromQuery)({ baseVersion: _baseVersion });
                }, disabled: ((_f = (_e = compare === null || compare === void 0 ? void 0 : compare.logs) === null || _e === void 0 ? void 0 : _e.length) !== null && _f !== void 0 ? _f : 0) < 2, hasMoreVersions: ((_h = (_g = compare === null || compare === void 0 ? void 0 : compare.logs) === null || _g === void 0 ? void 0 : _g.length) !== null && _h !== void 0 ? _h : 0) > 1, showVersionDetails: true, useComponentVersions: useVersions, useCurrentVersionLog: useVersion, PlaceholderComponent: component_ui_version_dropdown_1.DetailedVersion })),
        react_1.default.createElement("div", { className: component_compare_version_picker_module_scss_1.default.dropdownContainer },
            react_1.default.createElement("span", { className: component_compare_version_picker_module_scss_1.default.titleText }, "With"),
            react_1.default.createElement(component_ui_version_dropdown_1.VersionDropdown, { className: (0, classnames_1.default)(component_compare_version_picker_module_scss_1.default.componentCompareVersionContainer, component_compare_version_picker_module_scss_1.default.right), dropdownClassName: component_compare_version_picker_module_scss_1.default.componentCompareDropdown, placeholderClassName: component_compare_version_picker_module_scss_1.default.componentCompareVersionPlaceholder, menuClassName: component_compare_version_picker_module_scss_1.default.componentCompareVersionMenu, disabled: true, loading: componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.loading, currentVersion: compareVersion, PlaceholderComponent: component_ui_version_dropdown_1.DetailedVersion, useCurrentVersionLog: useVersion, showVersionDetails: true }))));
}
exports.ComponentCompareVersionPicker = ComponentCompareVersionPicker;
//# sourceMappingURL=component-compare-version-picker.js.map